;******************************** Sub-Intern *******************************
; Sub: Speicher als 32-Bit (4-Byte) Tabelle ausgeben
; Parameter:    X - Adresse
; Parameter:    Y - Lnge
; Return:       - 
; Scratch-Reg:  -
;***************************************************************************
debug_32bit_tab:
		push	ZH
		push	ZL
		push	YH
		push	YL

		rcall	send_newline

		lsr		YH					; /4
		ror		YL
		lsr		YH
		ror		YL					
		lsr		YH					; /4
		ror		YL
		lsr		YH
		ror		YL					

debug_32bit_tab_line_loop:
		mov		TEMP_A,XH			; Adresse senden
		rcall	send_byte_hex
		mov		TEMP_A,XL
		rcall	send_byte_hex

		ldi		TEMP_B,16			; Bytecounter

debug_32bit_tab_byte_loop:
		ldi		TEMP_A,' '			; Leerzeichen
		rcall	send_byte				

		ld		TEMP_A,X+
		rcall	send_byte_hex

		dec		TEMP_B
		brne	debug_32bit_tab_byte_loop

		rcall	send_newline
		sbiw	Y,1
		brne	debug_32bit_tab_line_loop

		pop		YL
		pop		YH
		pop		ZL
		pop		ZH
		ret

;******************************** Sub-Intern *******************************
; Sub: Sendet die Registerinhalte des 6510 
; Parameter:
; Parameter:
; Return:       - 
; Scratch-Reg:  -
;***************************************************************************
debug_6510:
		push	ZH
		push	ZL
		push	YH
		push	YL

		ldi		TEMP_A,'P'
		rcall	send_byte

		ldi		TEMP_A,'C'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		mov		TEMP_A,YH
		rcall	send_byte_hex

		mov		TEMP_A,YL
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'S'
		rcall	send_byte

		ldi		TEMP_A,'P'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		ldi		TEMP_A,$01
		rcall	send_byte_hex

		mov		TEMP_A,SP
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'A'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		mov		TEMP_A,AKKU
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'X'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		mov		TEMP_A,X_REG
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'Y'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		mov		TEMP_A,Y_REG
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'S'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		mov		TEMP_A,STATUS
		rcall	send_byte_hex

		ldi		TEMP_A,' '
		rcall	send_byte

		ldi		TEMP_A,'B'
		rcall	send_byte

		ldi		TEMP_A,':'
		rcall	send_byte

		ld		TEMP_A,Y
		rcall	send_byte_hex

		rcall	send_newline

		cpi		SP,$FF					; Stackpointer auf Stackbeginn?
		breq	debug_6510_end

		mov		XL,SP
		inc		XL
		ldi		XH,high(STACKPAGE)

		load_p	Z,(2*debug_stack)
		rcall	send_text
		rcall	send_newline

		load_p	Y,32

		rcall	debug_32bit_tab
		rcall	send_newline

debug_6510_end:
		pop		YL
		pop		YH
		pop		ZL
		pop		ZH

		ret

